﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class CameraBehaviour : MonoBehaviour {

    Camera camera;
    public float closestSize, farthestSize;
    private Vector2 mouseDragPositionStart;
    private Vector3 cameraDragPositionStart;
    public int leftBorder, topBorder, rightBorder, downBorder;


	// Use this for initialization
	void Start () {
        //Checking if sizes are entered correctly
        if (closestSize > farthestSize)
        {
            float youDoneFuckedUp = farthestSize;
            farthestSize = closestSize;
            closestSize = youDoneFuckedUp;
        }
        if (leftBorder > rightBorder)
        {
            int youDoneFuckedUp = leftBorder;
            leftBorder = rightBorder;
            rightBorder = youDoneFuckedUp;
        }
        if (downBorder > topBorder)
        {
            int youDoneFuckedUp = downBorder;
            downBorder = topBorder;
            topBorder = youDoneFuckedUp;
        }
        camera = GetComponent<Camera>();
	}
	

	// Update is called once per frame
	void Update () {
        //Zooming in and out
        if (Input.GetAxis("Mouse ScrollWheel") != 0)
        {
            camera.orthographicSize /= 1 + Input.GetAxis("Mouse ScrollWheel"); 
            //Correcting zoom if zooming out too far
            if (camera.orthographicSize > farthestSize)
            {
                camera.orthographicSize = farthestSize;
            }
            //Correcting zoom if zooming in too closely
            else if (camera.orthographicSize < closestSize)
            {
                camera.orthographicSize = closestSize;
            }

            CheckBorders(false);
        }
       
        //save mouse and camera position if dragging the screen
        if (Input.GetMouseButtonDown(2))
        {
            mouseDragPositionStart = Input.mousePosition;
            cameraDragPositionStart = transform.position;
        }
        //drag the screen
        if (Input.GetMouseButton(2))
        {
            transform.position = cameraDragPositionStart + 0.0038f* camera.orthographicSize * new Vector3(mouseDragPositionStart.x - Input.mousePosition.x, mouseDragPositionStart.y - Input.mousePosition.y, 0);
            CheckBorders(false);//TODO zet op true, zodra de functie hieronder werkt
        }
	}
    /// <summary>
    ///  Checks whether the camera's view exits the playfield, and corrects it in case it does
    /// </summary>
    /// <param name="mouse">If the function is called from the mouse-dragging bit, rather than the zooming bit, the mousestartPosition needs to be changed, 
    /// to not have to mouse the mouse back all the way.  //TODO maak dit werkend
    /// </param>

    void CheckBorders(bool mouse)
    {
        Vector3 newPosition = transform.position;
        float currentSize = camera.orthographicSize;
        //Camera aspect takes care of the differing aspect ratios
        if (newPosition.x < leftBorder + currentSize * camera.aspect)
        {
            newPosition.x = leftBorder + currentSize * camera.aspect;
            if (mouse) mouseDragPositionStart.x = Input.mousePosition.x;
        }
        else if (newPosition.x > rightBorder - currentSize * camera.aspect)
        {
            newPosition.x = rightBorder - currentSize * camera.aspect;
            if (mouse) mouseDragPositionStart.x = Input.mousePosition.x;
        }
        if (newPosition.y < downBorder + currentSize)
        {
            newPosition.y = downBorder + currentSize;
            if (mouse) mouseDragPositionStart.y = Input.mousePosition.y;
        }
        else if (newPosition.y > topBorder - currentSize)
        {
            newPosition.y = topBorder - currentSize;
            if (mouse) mouseDragPositionStart.y = Input.mousePosition.y;
        }
        transform.position = newPosition;
    }

    void OnDrawGizmos()
    {
        //Draw the borders of where the camera may go
        Gizmos.color = Color.blue;
        Gizmos.DrawLine(new Vector3(leftBorder, topBorder, 0), new Vector3(rightBorder, topBorder, 0));
        Gizmos.DrawLine(new Vector3(leftBorder, topBorder, 0), new Vector3(leftBorder, downBorder, 0));
        Gizmos.DrawLine(new Vector3(leftBorder, downBorder, 0), new Vector3(rightBorder, downBorder, 0));
        Gizmos.DrawLine(new Vector3(rightBorder, topBorder, 0), new Vector3(rightBorder, downBorder, 0));
    }
}
