﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class Currency : MonoBehaviour
{
    // Storage variables
    private ArrayList houses;
    private int maximumHealth;

    public int setFirstAmountOfMoney;
    public GameObject moneyFeedbackPrefab;
    public Transform moneyFeedbackHolder;

    [Header("Values for determining income")]
    public int maximumIncome = 100;

    private void Start ()
    {
        // Reset money from previous session
        PlayerPrefs.SetInt("Money", setFirstAmountOfMoney);

        // create list and add every house in the list
        houses = new ArrayList();
        foreach (PlacementProperties child in GetComponentsInChildren<PlacementProperties>())
        {
            if (child.type == PlacementProperties.ObjectTypes.Blockade && child.objectName == "House")
                houses.Add(child);
        }

        // Set maximum health for calculating income later
        var house = (PlacementProperties)houses[0];
        maximumHealth = (int)house.health;
    }

    public void CalculateHouseIncome () //TODO roep aan aan het einde van de wave
    {
        houses = new ArrayList();
        // Make temporary variable to store income from this wave in
        float tempIncome = 0;

        // Loop through all houses
        foreach (PlacementProperties house in GetComponentsInChildren<PlacementProperties>())
        {
            if (house.type == PlacementProperties.ObjectTypes.Blockade && house.objectName == "House")
            {
                // Calculate income
                tempIncome += house.health / maximumHealth * maximumIncome;

                GameObject feedback = Instantiate(moneyFeedbackPrefab);
                feedback.GetComponent<MoneyFeedbackBehaviour>().creator = house.transform;
                feedback.transform.SetParent(moneyFeedbackHolder, false);
                feedback.transform.position = Camera.main.WorldToScreenPoint(house.transform.position);
                feedback.GetComponent<Text>().text = "$" + ((int)(house.health / maximumHealth * maximumIncome)).ToString();
            }
        }

        // Add the income to a global variable
        PlayerPrefs.SetInt("Money", PlayerPrefs.GetInt("Money") + (int)tempIncome);
    }
}
