﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.SceneManagement;

public class MenuScript : MonoBehaviour {

    public GameObject exitButton, playButton;
    int state; //0 = main menu
    GameObject canvas;

	// Use this for initialization
	void Start () {
        canvas = GameObject.Find("Canvas");
	}
	
	// Update is called once per frame
	void Update () {
        if (Input.GetKey("escape"))
            Application.Quit();
    }

    public void ButtonPress(string buttonName)
    {
        switch (buttonName)
        {
            case "ExitButton": //TODO werkt niet om de een of andere reden.
                Application.Quit();
                break;
                
            case "PlayButton":
                SceneManager.LoadScene("Sand"); 
                break;
        }
    }

    public void SwitchState(int state)
    {
        this.state = state;
        GameObject[] buttons = GameObject.FindGameObjectsWithTag("MenuButton");
        foreach (GameObject button in buttons)
        {
            GameObject.Destroy(button);
        }
        PopulateMenu();
    }

    public void PopulateMenu()
    {
        switch (state)
        {
            //main menu
            case 0:
                GameObject pB = GameObject.Instantiate(playButton, canvas.transform);
                GameObject eB = GameObject.Instantiate(exitButton, canvas.transform);

                pB.name = playButton.name;
                pB.GetComponent<RectTransform>().position += pB.transform.parent.GetComponent<RectTransform>().position;
                eB.name = exitButton.name;
                eB.GetComponent<RectTransform>().position += eB.transform.parent.GetComponent<RectTransform>().position;
                break;
            //nothing yet
            case 1:
                break;
            //nothing yet
            case 2:
                break;
        }
    }
}
