﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class UpdateInfoPanel : MonoBehaviour {
    public GameObject gameManager;
    private TileSelector tileSelector;
    private GameObject placementObjectMemory;
    private Transform title;
    private Transform description;
    private Transform cost;

    private void Start()
    {
        tileSelector = gameManager.GetComponent<TileSelector>();
        title = transform.GetChild(0);
        description = transform.GetChild(1);
        cost = transform.GetChild(2);
        gameObject.GetComponent<Image>().enabled = false;
    }

    private void Update()
    {
        // Only update if variable changes
        if (tileSelector.GetPlacementObject() != placementObjectMemory)
        {
            if (tileSelector.GetPlacementObject() != null)
            {
                // Update title and description
                gameObject.GetComponent<Image>().enabled = true;
                title.GetComponent<Text>().enabled = true;
                description.GetComponent<Text>().enabled = true;
                cost.GetComponent<Text>().enabled = true;
                title.GetComponent<Text>().text = tileSelector.GetPlacementObject().GetComponent<PlacementProperties>().objectName;
                description.GetComponent<Text>().text = tileSelector.GetPlacementObject().GetComponent<PlacementProperties>().description;
                cost.GetComponent<Text>().text = "Cost: " + tileSelector.GetPlacementObject().GetComponent<PlacementProperties>().cost;
            }
            else
            {
                // Update title and description
                gameObject.GetComponent<Image>().enabled = false;
                title.GetComponent<Text>().enabled = false;
                description.GetComponent<Text>().enabled = false;
                cost.GetComponent<Text>().enabled = false;
            }
        }

        // Store variable in memory
        placementObjectMemory = tileSelector.GetPlacementObject();
    }
}
