﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class WaterDetector : MonoBehaviour {

    private WaterIndex waterIndex;

    private void Start()
    {
        waterIndex = GameObject.Find("WaterTiles").GetComponent<WaterIndex>();
    }

    private void Update()
    {
        GameObject[] waterTilesInTile = new GameObject[4];

        waterTilesInTile[0] = waterIndex.FindTileByPosition(transform.position.x - waterIndex.offset, transform.position.y + waterIndex.offset);
        waterTilesInTile[1] = waterIndex.FindTileByPosition(transform.position.x + waterIndex.offset, transform.position.y + waterIndex.offset);
        waterTilesInTile[2] = waterIndex.FindTileByPosition(transform.position.x - waterIndex.offset, transform.position.y - waterIndex.offset);
        waterTilesInTile[3] = waterIndex.FindTileByPosition(transform.position.x + waterIndex.offset, transform.position.y - waterIndex.offset);

        foreach (GameObject waterTile in waterTilesInTile)
        {
            if (waterTile != null && waterTile.GetComponent<WaterBehaviour>().WaterHeight > 0)
            {
                if (!GetComponent<PlacementProperties>().destroyed)
                {
                    waterTile.GetComponent<WaterBehaviour>().isOccupied = true;
                    waterTile.GetComponent<WaterBehaviour>().occupier = gameObject;
                    waterTile.GetComponent<WaterBehaviour>().occupantType = gameObject.GetComponent<PlacementProperties>().type.ToString();
                }
                else
                {
                    waterTile.GetComponent<WaterBehaviour>().isOccupied = false;
                }
            }
            else if (waterTile != null && waterTile.GetComponent<WaterBehaviour>().deltaWaterHeight == 0)
                waterTile.GetComponent<WaterBehaviour>().isOccupied = false;
        }
    }
}
