﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

/*
 * IMPORTANT:
 * 
 * The waterFinish prefab has to be moved per 0.5 units over the x-axis, starting at 0. Othewise it
 * won't find the watertiles
 */
public class WaterFinish : MonoBehaviour {

    private WaterIndex waterIndex;

    private bool[] tilesArrived;

    private int height = 50;

    public float treshold;

    private void Start()
    {
        waterIndex = GameObject.Find("WaterTiles").GetComponent<WaterIndex>();

        tilesArrived = new bool[waterIndex.height];
    }

    private void Update()
    {
        // Check how much water tiles arrived at the finish
        float startY = 0.25f;
        float dY = 0.5f;

        for (int i = 0; i < waterIndex.height; i++)
        {
            GameObject waterTile = null;
            waterTile = waterIndex.FindTileByPosition(transform.localPosition.x, startY - dY * i);

            if (waterTile != null)
            {
                // Watertile found, check if it's water
                if (waterTile.GetComponent<WaterBehaviour>().WaterHeight > treshold)
                {
                    tilesArrived[i] = true;
                } else
                {
                    tilesArrived[i] = false;
                }
            }
        }
    }

	private void OnDrawGizmos()
    {
        // Draw the water detector line
        Gizmos.color = Color.red;
        Gizmos.DrawLine(transform.position + new Vector3(0, height / 2, 0), transform.position - new Vector3(0, height / 2, 0));
    }

    /// <summary>
    /// Returns the amount of arrived water tiles
    /// </summary>
    /// <returns></returns>
    public int GetArrivedTilesCount()
    {
        int count = 0;

        for(int i = 0; i < tilesArrived.Length; i++)
        {
            if (tilesArrived[i])
                count++;
        }

        return count;
    }
}
