﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class WaveControllerScript : MonoBehaviour {

    WaterIndex waterGrid;
    public int waveNumber = 0;
    bool waving = false;
    bool BuildPhase = false;

    //time based
    int secondsTillNextWave = 0;
    public int buildDuration; //Lenghf of the time the user has to build stuff.

    public int shoreLine;

    float waveHeight;
    public float waveHeightStart;
    public float waveHeightIncrease;

    public AudioSource mainMusic;
    public AudioSource waveMusic;


    WaterFinish rightBorder;
    WaterFinish leftBorder;

    public UIScript timeAndMoney;
    Currency currency;

    // Use this for initialization
    void Start () {
        currency = GameObject.Find("Grid").GetComponent<Currency>();
        waterGrid = GameObject.Find("WaterTiles").GetComponent<WaterIndex>();
        rightBorder = GameObject.Find("WaterFinish").GetComponent<WaterFinish>();
        leftBorder = GameObject.Find("WaterShore").GetComponent<WaterFinish>();
        secondsTillNextWave = buildDuration;
        waveHeight = waveHeightStart;
        StartBuild();
        waterGrid.StartTsunami(shoreLine, buildDuration);
    }

    private IEnumerator BuildClock()
    {
        yield return new WaitForSeconds(1);
        secondsTillNextWave -= 1;
        timeAndMoney.UpdateTime(secondsTillNextWave);
        if (secondsTillNextWave == 0)
        {
            SendWave();
        }
        else {
            StartCoroutine(BuildClock());
        }
    }
    void SendWave()
    {
        mainMusic.Stop();
        waveMusic.Play();
        BuildPhase = false;
        waterGrid.drainRate = 0;
        waterGrid.ActivateFlowing();
        secondsTillNextWave = buildDuration;
        waterGrid.ActivateWave(waveHeight);
        waving = true;
        GetComponent<TileSelector>().canBuild = false;
        //
    }
    void StartBuild()
    {
        mainMusic.Play();
        waveMusic.Stop();
        BuildPhase = true;
        if (waveNumber != 0)
        {
            currency.CalculateHouseIncome();
        }
        waveNumber++;
        secondsTillNextWave = buildDuration;
        waveHeight += waveHeightIncrease;
        GetComponent<TileSelector>().canBuild = true;
        StartCoroutine(BuildClock());
        waterGrid.drainRate = 0.1f;
    }

    
    void FixedUpdate()
    {
        if (waving)
        {
            waterGrid.ActivateWave(waveHeight);
        }

        if (rightBorder.GetArrivedTilesCount() > 10 && waving && !BuildPhase)
        {
            waving = false;
            waterGrid.drainRate = 0.05f;
        }
        else if (leftBorder.GetArrivedTilesCount() < 10 && !waving && !BuildPhase)
        {
            rightBorder.transform.position += new Vector3(4, 0, 0);
            StartBuild();
        }
    }

    void OnDrawGizmos()
    {
        Gizmos.color = Color.blue;
        Gizmos.DrawLine(new Vector3(shoreLine, 10000, 0), new Vector3(shoreLine, -10000, 0));
    }
}
